# include <mouse.h>
# include <dos.h>
# include <stdio.h>
# define MOUSE 0x33

int Reset_Mouse(void)
// this function resets the mouse for display and returns the number of
// buttons the mouse has.
	{
	int status,buttons;
	_AX=0x00;
	geninterrupt ( MOUSE );
	status=_AH;
	buttons=_BX;
	if(!status){
		printf("Driver or Mouse not installed");
		return 0;
		}
	if (buttons==-1)  return 2;
	if (buttons==3)  return 3;
	}

void Show_Mouse (void)
// This function reveals the mouse on the display.
	{
	_AX=0x01;
	geninterrupt(MOUSE);
	}

void Hide_Mouse (void)
// this function turns off the mouse cursor.
	{
	_AX=0x02;
	geninterrupt(MOUSE);
	}

void Mouse_Position(int *x,int *y)
// This function returns the x and y coordinates of the mouse cursor.
	{
	_AX=0x03;
	geninterrupt(MOUSE);
	*x=_CX;
	*y=_DX;
	}

int Right_Button(void)
// This function returns nonzero if the right mouse button was pressed.
	{
	int status;
	_AX=0x03;
	geninterrupt(MOUSE);
	status=_BX;
	return(status & 2);
	}

int Left_Button(void)
// this function returns nonzero if the left mouse button was pressed.
	{
	int status;
	_AX=0x03;
	geninterrupt(MOUSE);
	status=_BX;
	return(status & 1);
	}

void Put_Mouse(int x,int y)
// this function positions the mouse within the mouse virtual screen.
	{
	_CX=x;
	_DX=y;
	_AX=0x04;
	geninterrupt(MOUSE);
	}

void PButton_Status(int button,int* times,int *x,int *y)
// This function returns the # of times the specified button was pressed
// since the last call to PButton_Status and the row and column at the last
// press. Left button is 0, right button is 1, middle button is 2.
	{
	_AX=0x05;
	_BX=button;
	geninterrupt(MOUSE);
	*times=_BX;
	*x=_CX;
	*y=_DX;
	}

void RButton_Status(int button,int* times,int *x,int *y)
// This function performs a similar function as PButton_Status but gives
// information of button release.
	{
	_AX=0x06;
	_BX=button;
	geninterrupt(MOUSE);
	*times=_BX;
	*x=_CX;
	*y=_DX;
	}

void Set_MRange(int minx,int maxx,int miny,int maxy)
// This function places limits on the mouse cursor range of position within
// the mouse virtual screen.
	{
	// set horizontal range
	_AX=0x07;
	_CX=minx;
	_DX=maxx;
	geninterrupt(MOUSE);
	// set vertical range
	_AX=0x08;
	_CX=miny;
	_DX=maxy;
	geninterrupt(MOUSE);
	}
void Mouse_Info(int *x,int *y,int *button)
  {
       int temp;
       _AX=3;
       geninterrupt(MOUSE);

       // which buttons pressed: 1=left, 2=right, 3=both
       temp=_BX;
       *button=temp;

       // horizontal coordinates
       *y =_CX;

       // vert coordinates
       *x=_DX;
  }

